////////////////////////////////////////////////////////////////////////////////
//
//Datablocks go here!
//
///////////////////////////////////////////////////////////////////
//Convoy Datablocks
///////////////////////////////////////////////////////////////////

$DamageType::Nuke			= 40;
$DamageTypeText[40]		= 'Nuke';

datablock ShockwaveData(genShockwaveRealSlow)
{
   width = 24.0;
   numSegments = 30;
   numVertSegments = 6;
   velocity = 2;
   acceleration = 2.0;
   lifetimeMS = 12000;
   height = 80.0;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shocklanceZap";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.0 0.03 1.0";
   colors[1] = "1.0 0.0 0.03 1.0";
   colors[2] = "1.0 0.0 0.03 1.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};

datablock ExplosionData(genEffectWaveRealSlow)
{
   explosionShape = "";
   soundProfile = "";
   faceViewer = true;
   shockwave = genShockwaveRealSlow;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 800.0;
};

datablock ItemData(genGrenRealSlow)
{
	className = Weapon;
	shapeFile = "turret_muzzlepoint.dts";
	mass = 0.7;
	elasticity = 0.2;
   	friction = 1;
   	pickupRadius = 1;
   	maxDamage = 0.01;
	explosion = "genEffectWaveRealSlow";
	underwaterExplosion = "";
   	indirectDamage      = 0.0;
   	damageRadius        = 0.01;
   	radiusDamageType    = $DamageType::Nuke;
   	kickBackStrength    = 1000;
   	computeCRC = false;
};

datablock ShockwaveData(genShockwaveSlow)
{
   width = 18.0;
   numSegments = 32;
   numVertSegments = 7;
   velocity = 5;
   acceleration = 10.0;
   lifetimeMS = 12000;
   height = 60.0;
   verticalCurve = 0.8;
   is2D = false;

   texture[0] = "special/shocklanceZap";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.0 0.13 1.0";
   colors[1] = "1.0 0.0 0.13 1.0";
   colors[2] = "1.0 0.0 0.13 1.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};

datablock ExplosionData(genEffectWaveSlow)
{
   explosionShape = "";
   soundProfile = "";
   faceViewer = true;
   shockwave = genShockwaveSlow;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 2.3;
   camShakeRadius = 400.0;
};

datablock ItemData(genGrenSlow)
{
	className = Weapon;
	shapeFile = "turret_muzzlepoint.dts";
	mass = 0.7;
	elasticity = 0.2;
   	friction = 1;
   	pickupRadius = 1;
   	maxDamage = 0.01;
	explosion = "genEffectWaveSlow";
	underwaterExplosion = "";
   	indirectDamage      = 0.0;
   	damageRadius        = 0.01;
   	radiusDamageType    = $DamageType::nuke;
   	kickBackStrength    = 1000;
   	computeCRC = false;
};

datablock ShockwaveData(genShockwaveMed)
{
   width = 12.0;
   numSegments = 34;
   numVertSegments = 8;
   velocity = 10;
   acceleration = 20.0;
   lifetimeMS = 12000;
   height = 40.0;
   verticalCurve = 1.2;
   is2D = false;

   texture[0] = "special/shocklanceZap";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.13 0.03 1.0";
   colors[1] = "1.0 0.13 0.03 1.0";
   colors[2] = "1.0 0.13 0.03 1.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};

datablock ExplosionData(genEffectWaveMed)
{
   explosionShape = "";
   soundProfile = "";
   faceViewer = true;
   shockwave = genShockwaveMed;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 4.3;
   camShakeRadius = 200.0;
};

datablock ItemData(genGrenMed)
{
	className = Weapon;
	shapeFile = "turret_muzzlepoint.dts";
	mass = 0.7;
	elasticity = 0.2;
   	friction = 1;
   	pickupRadius = 1;
   	maxDamage = 0.01;
	explosion = "genEffectWaveMed";
	underwaterExplosion = "";
   	indirectDamage      = 0.0;
   	damageRadius        = 0.01;
   	radiusDamageType    = $DamageType::Nuke;
   	kickBackStrength    = 1000;
   	computeCRC = false;
};

datablock ShockwaveData(genShockwaveLong)
{
   width = 6.0;
   numSegments = 48;
   numVertSegments = 9;
   velocity = 20;
   acceleration = 40.0;
   lifetimeMS = 12000;
   height = 20.0;
   verticalCurve = 1.5;
   is2D = false;

   texture[0] = "special/shocklanceZap";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.23 0.03 1.0";
   colors[1] = "1.0 0.23 0.03 1.0";
   colors[2] = "1.0 0.23 0.03 1.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};

datablock ExplosionData(genEffectWaveLong)
{
   explosionShape = "";
   soundProfile = "";
   faceViewer = true;
   shockwave = genShockwaveLong;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 8.6;
   camShakeRadius = 100.0;
};

datablock ItemData(genGrenLong)
{
	className = Weapon;
	shapeFile = "turret_muzzlepoint.dts";
	mass = 0.7;
	elasticity = 0.2;
   	friction = 1;
   	pickupRadius = 1;
   	maxDamage = 4.00;
	explosion = "genEffectWaveLong";
	underwaterExplosion = "";
   	indirectDamage      = 0.5;
   	damageRadius        = 12.00;
   	radiusDamageType    = $DamageType::Nuke;
   	kickBackStrength    = 1000;
   	computeCRC = false;
};

datablock ShockwaveData(genShockwaveRealFast)
{
   width = 1.0;
   numSegments = 60;
   numVertSegments = 10;
   velocity = 40;
   acceleration = 60.0;
   lifetimeMS = 12000;
   height = 10.0;
   verticalCurve = 1.8;
   is2D = false;

   texture[0] = "special/shocklanceZap";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.83 0.03 1.0";
   colors[1] = "1.0 0.83 0.03 1.0";
   colors[2] = "1.0 0.83 0.03 1.0";

   mapToTerrain = true;
   orientToNormal = false;
   renderBottom = false;
};

datablock ExplosionData(genEffectWaveRealFast)
{
   explosionShape = "";
   soundProfile = "";
   faceViewer = true;
   shockwave = genShockwaveRealFast;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 16.3;
   camShakeRadius = 50.0;
};

datablock ItemData(genGrenRealFast)
{
	className = Weapon;
	shapeFile = "turret_muzzlepoint.dts";
	mass = 0.7;
	elasticity = 0.2;
   	friction = 1;
   	pickupRadius = 1;
   	maxDamage = 5.0;
	explosion = "genEffectWaveRealFast";
	underwaterExplosion = "";
   	indirectDamage      = 1.0;
   	damageRadius        = 50.0;
   	radiusDamageType    = $DamageType::Nuke;
   	kickBackStrength    = 1000;
   	computeCRC = false;
};


datablock ExplosionData(NukeSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 0;

   offset = 0.0;

   playSpeed = 0.1;


   sizes[0] = "17.0 17.0 17.0";
   sizes[1] = "20.0 20.0 20.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(NukeSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 100;

   offset = 0.0;

   playSpeed = 0.1;


   sizes[0] = "37.0 37.0 37.0";
   sizes[1] = "40.0 40.0 40.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(NukeSubExplosion3)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 200;

   offset = 0.0;

   playSpeed = 0.1;


   sizes[0] = "57.0 57.0 57.0";
   sizes[1] = "60.0 60.0 60.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(NukeSubExplosion4)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 300;

   offset = 0.0;

   playSpeed = 0.1;


   sizes[0] = "77.0 77.0 77.0";
   sizes[1] = "80.0 80.0 80.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(NukeSubExplosion5)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 400;

   offset = 0.0;

   playSpeed = 0.1;


   sizes[0] = "97.0 97.0 97.0";
   sizes[1] = "100.0 100.0 100.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(NukeSubExplosion6)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 500;

   offset = 0.0;

   playSpeed = 0.1;


   sizes[0] = "117.0 117.0 117.0";
   sizes[1] = "120.0 120.0 120.0";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(NukeExplosion)
{
   soundProfile   = BombExplosionSound;
   particleEmitter = VehicleBombExplosionEmitter;
   particleDensity = 250;
   particleRadius = 12.5;
   faceViewer = true;

   subExplosion[0] = NukeSubExplosion1;
   subExplosion[1] = NukeSubExplosion2;
   subExplosion[2] = NukeSubExplosion3;
   subExplosion[3] = NukeSubExplosion4;
   subExplosion[4] = NukeSubExplosion5;
   subExplosion[5] = NukeSubExplosion6;

};

datablock ItemData(nukeBasic)
{
	className = Weapon;
	maxDamage = 250.0;
	indirectDamage      = 4.0;
   	damageRadius        = 1500.0;
   	radiusDamageType    = $DamageType::Nuke;
   	computeCRC = false;
	shapeFile = "turret_muzzlepoint.dts";
	mass = 0.7;
	elasticity = 0.2;
   	friction = 1;
   	pickupRadius = 1;
	explosion = "NukeExplosion";
	underwaterExplosion = "";
   	kickBackStrength    = 25000;
};


//**************************************************************
// WILDCAT GRAV CYCLE - convoy version: inherits from ScoutVehicle
//**************************************************************
//**************************************************************
// VEHICLE CHARACTERISTICS - only changes different attributes
//**************************************************************
$DamageType::Torpedo		= 41;
$DamageTypeText[41]		= 'Torpedo';


datablock HoverVehicleData(ScoutVehicleConvoy) : ScoutVehicle
{
   shieldDamageScale[$DamageType::Nuke]	= 50.0;
   damageScale[$DamageType::Nuke]	= 5.0;
   shieldDamageScale[$DamageType::Torpedo] = 1.2;
   damageScale[$DamageType::Torpedo] 	 = 0.7;

   floatingGravMag = 6.5; //was 3.5

   computeCRC = false;

   maxDamage = 0.60;
   destroyedLevel = 0.60;

   isShielded = true;
   rechargeRate = 0.7;
   energyPerDamagePoint = 75;
   maxEnergy = 350;
   minJetEnergy = 15;
   jetEnergyDrain = 1.2;

   // Rigid Body
   mass = 400;
   bodyFriction = 0.1;
   bodyRestitution = 0.5;  
   softImpactSpeed = 20;       // Play SoftImpact Sound
   hardImpactSpeed = 28;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 130;
   speedDamageScale = 0.002;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 83;
   collDamageMultiplier   = 0.003;

   dragForce            = 20 / 45.0;
   vertFactor           = 0.0;
   floatingThrustFactor = 0.65;  //was .35

   mainThrustForce    = 30;
   reverseThrustForce = 20;
   strafeThrustForce  = 8;
   turboFactor        = 1.4;

   brakingForce = 25;
   brakingActivationSpeed = 4;

   stabLenMin = 2.25;
   stabLenMax = 3.75;
   stabSpringConstant  = 30;
   stabDampingConstant = 16;

   gyroDrag = 16;
   normalForce = 30;
   restorativeForce = 20;
   steeringForce = 30;
   rollForce  = 15;
   pitchForce = 7;

   numWeapons = 1;

};

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShockwaveData(ConcussionGrenadeTorpedoShockwave)
{
   width = 8.0;
   numSegments = 80;
   numVertSegments = 3;
   velocity = 10;
   acceleration = 15.0;
   lifetimeMS = 3900;
   height = 60.0;
   is2D = true;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.8 0.8 1.0 1.00";
   colors[1] = "0.8 0.5 1.0 0.20";
   colors[2] = "0.2 0.8 1.0 0.0";
};

datablock ExplosionData(TorpedoExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   soundProfile   = MissileExplosionSound;
   //particleEmitter = PlasmaExplosionEmitter;
   particleDensity = 150;
   particleRadius = 1.25;
   faceViewer = true;

   sizes[0] = "1.0 1.0 1.0";
   sizes[1] = "1.0 1.0 1.0";
   times[0] = 0.0;
   times[1] = 1.5;

   shockwave =  ConcussionGrenadeTorpedoShockwave;

   emitter[0] = ConcussionGrenadeSparkEmitter;
   emitter[1] = ConcussionGrenadeCrescentEmitter;

   shakeCamera = true;
   camShakeFreq = "4.0 5.0 4.5";
   camShakeAmp = "70.0 70.0 70.0";
   camShakeDuration = 1.6;
   camShakeRadius = 75.0;

};


//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearFlareProjectileData(Torpedo)
{
   projectileShapeName = "plasmabolt.dts";
   scale               = "2.0 2.0 2.0";
   faceViewer          = true;
   directDamage        = 3.7;
   hasDamageRadius     = true;
   indirectDamage      = 0.85;
   damageRadius        = 50.0;
   kickBackStrength    = 0.0;
   radiusDamageType    = $DamageType::Torpedo;

   explosion           = "TorpedoExplosion";
   splash              = PlasmaSplash;

   dryVelocity       = 255.0;
   wetVelocity       = -1;
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 5000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   //activateDelayMS = 100;
   activateDelayMS = -1;

   size[0]           = 0.2;
   size[1]           = 0.5;
   size[2]           = 0.1;


   numFlares         = 35;
   flareColor        = "1 0.75 0.25";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound        = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;
   
   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 0.75 0.25";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(TorpedoAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_plasma.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some torpedos";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------

datablock ItemData(TorpedoLauncher)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_plasma.dts";
   image = TorpedoImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a torpedo launcher";
};

datablock ShapeBaseImageData(TorpedoImage)
{
   className = WeaponImage;
   shapeFile = "weapon_missile.dts";
   item = TorpedoLauncher;
   ammo = TorpedoLauncherAmmo;
   

   mountPoint = 12;
   //**original**   offset = ".73 0 0";
   offset = ".83 0.0 0.0";

   armThread = lookms;
   emap = true;

   projectile = Torpedo;
   projectileType = LinearFlareProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 50;
   fireEnergy = 80;
   fireTimeout = 125;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = PlasmaSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "CheckWet";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.1;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
   stateEmitterTime[3] = 0.2;
   stateSound[3] = PlasmaFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.6;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = PlasmaReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = PlasmaDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
   
   stateName[7]       = "WetFire";
   stateSound[7]      = PlasmaFireWetSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "Ready";
   
   stateName[8]               = "CheckWet";
   stateTransitionOnWet[8]    = "WetFire";
   stateTransitionOnNotWet[8] = "Fire"; 
};


//**************************************************************
// BEOWULF ASSAULT VEHICLE
//**************************************************************
//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock HoverVehicleData(AssaultVehicleConvoy) : AssaultVehicle
{
   shieldDamageScale[$DamageType::Nuke]	= 50.0;
   damageScale[$DamageType::Nuke]	= 4.0;
   shieldDamageScale[$DamageType::Torpedo] = 1.2;
   damageScale[$DamageType::Torpedo] 	 = 0.7;

   floatingGravMag = 4.5;

   computeCRC = false;
                                                 
   weaponNode = 1;

   drag = 0.0;
   density = 0.9;

   cameraMaxDist = 20;
   cameraOffset = 3;
   cameraLag = 1.5;
   explosion = LargeGroundVehicleExplosion;
   explosionDamage = 0.5;
   explosionRadius = 5.0;

   maxSteeringAngle = 0.5;  // 20 deg.

   maxDamage = 2.15;
   destroyedLevel = 2.15;

   isShielded = true;
   rechargeRate = 1.0;
   energyPerDamagePoint = 215;
   maxEnergy = 800;
   minJetEnergy = 15;
   jetEnergyDrain = 2.0;

   // Rigid Body
   mass = 1500;
   bodyFriction = 0.8;
   bodyRestitution = 0.5;
   minRollSpeed = 3;
   gyroForce = 400;
   gyroDamping = 0.3;
   stabilizerForce = 20;
   minDrag = 5;
   softImpactSpeed = 15;       // Play SoftImpact Sound
   hardImpactSpeed = 18;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 87;
   speedDamageScale = 0.060;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 18;
   collDamageMultiplier   = 0.045;

   dragForce            = 20 / 20;
   vertFactor           = 0.0;
   floatingThrustFactor = 0.15;

   mainThrustForce    = 60;
   reverseThrustForce = 50;
   strafeThrustForce  = 50;
   turboFactor        = 2.0;

   brakingForce = 15;
   brakingActivationSpeed = 3;

   stabLenMin = 3.25;
   stabLenMax = 4;
   stabSpringConstant  = 50;
   stabDampingConstant = 20;

   gyroDrag = 10;
   normalForce = 20;
   restorativeForce = 10;
   steeringForce = 15;
   rollForce  = 5;
   pitchForce = 3;

   dustEmitter = TankDustEmitter;
   triggerDustHeight = 3.5;
   dustHeight = 1.0;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 3.6;
   dustTrailFreqMod = 15.0;
};

//**************************************************************
// WEAPONS
//**************************************************************


//-------------------------------------
// ASSAULT MORTAR (projectile)
//-------------------------------------

datablock GrenadeProjectileData(AssaultMortarConvoy) : AssaultMortar
{
   directDamage        = 5.2;
   hasDamageRadius     = true;
   indirectDamage      = 1.6;
   damageRadius        = 75.0;
   radiusDamageType    = $DamageType::TankMortar;
   kickBackStrength    = 2500;

   grenadeElasticity = 0.0;
   grenadeFriction   = 0.4;
   armingDelayMS     = 250;
   muzzleVelocity    = 85;
   drag              = 0.1;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0.1 0.4 0.1";
};

//-------------------------------------
// ASSAULT MORTAR CHARACTERISTICS
//-------------------------------------

datablock TurretImageData(AssaultMortarConvoyTurretBarrel) : AssaultMortarTurretBarrel
{
   mountPoint = 0;

   projectile = AssaultMortarConvoy;
   projectileType = GrenadeProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 87.00;
   minEnergy = 87.00;
   useCapacitor = true;

   // Turret parameters
   activationMS                        = 3000;
   deactivateDelayMS                   = 1000;
   thinkTimeMS                         = 200;
   degPerSecTheta                      = 360;
   degPerSecPhi                        = 360;
   attackRadius                        = 75;
};



//**************************************************************
// JERICHO FORWARD BASE (Mobile Point Base)
//**************************************************************
//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************
datablock WheeledVehicleData(MobileBaseVehicleConvoy) : MobileBaseVehicle
{
   shieldDamageScale[$DamageType::Nuke]	= 50.0;
   damageScale[$DamageType::Nuke]	= 1.0;
   shieldDamageScale[$DamageType::Torpedo] = 1.2;
   damageScale[$DamageType::Torpedo] 	 = 0.7;

   computeCRC = false;

   drag = 0.0;
   density = 20.0;

   cantAbandon = 1;
   cantTeamSwitch = 1;
   
   cameraMaxDist = 20;
   cameraOffset = 6;
   cameraLag = 1.5;
   explosion = LargeGroundVehicleExplosion;
   explosionDamage = 0.5;
   explosionRadius = 5.0;

   maxSteeringAngle = 0.3;  // 20 deg.

   // Rigid Body
   mass = 2000;
   bodyFriction = 0.8;
   bodyRestitution = 0.5;
   minRollSpeed = 3;
   gyroForce = 400;
   gyroDamping = 0.3;
   stabilizerForce = 10;
   minDrag = 10;
   softImpactSpeed = 15;       // Play SoftImpact Sound
   hardImpactSpeed = 25;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 12;
   speedDamageScale = 0.060;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 18;
   collDamageMultiplier   = 0.070;

   // Engine
   engineTorque = 7.0 * 745;
   breakTorque = 7.0 * 745;
   maxWheelSpeed = 20;

   // Springs
   springForce = 8000;
   springDamping = 1300;
   antiSwayForce = 6000;
   staticLoadScale = 2;

   // Tires
   tireRadius = 1.6;
   tireFriction = 10.0;
   tireRestitution = 0.5;
   tireLateralForce = 3000;
   tireLateralDamping = 400;
   tireLateralRelaxation = 1;
   tireLongitudinalForce = 12000;
   tireLongitudinalDamping = 600;
   tireLongitudinalRelaxation = 1;
   tireEmitter = TireEmitter;

   //   
   maxDamage = 12.85;
   destroyedLevel = 12.85;

   isShielded = true;
   energyPerDamagePoint = 125;
   maxEnergy = 600;
   jetForce = 2800;
   minJetEnergy = 60;
   jetEnergyDrain = 0.75;
   rechargeRate = 1.0;
};

//**************************************************************
// WEAPONS
//**************************************************************

datablock SensorData(MPBTurretMissileSensorConvoy) : MPBTurretMissileSensor
{
   detectRadius = 900;
};

datablock TurretData(MobileTurretBaseConvoy) : MobileTurretBase
{
   thetaMin      = 15;
   thetaMax      = 140;

   sensorColor = "0 212 45";
   sensorData = MPBTurretMissileSensorConvoy;
   sensorRadius = MPBTurretMissileSensorConvoy.detectRadius;
   canControl = true;
};




//**************************************************************
// SHRIKE SCOUT FLIER
//**************************************************************
//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************
datablock FlyingVehicleData(ScoutFlyerConvoy) : ScoutFlyer
{
   shieldDamageScale[$DamageType::Nuke]	= 50.0;
   damageScale[$DamageType::Nuke]	= 5.0;
   shieldDamageScale[$DamageType::Torpedo] = 1.2;
   damageScale[$DamageType::Torpedo] 	 = 0.7;

   computeCRC = false;

   drag    = 0.15;
   density = 1.0;

   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   maxDamage = 0.80;
   destroyedLevel = 0.80;

   isShielded = true;
   energyPerDamagePoint = 290;
   maxEnergy = 540;      // Afterburner and any energy weapon pool
   rechargeRate = 0.67;

   minDrag = 5;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)

   maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 400;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 300;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds
   
   // Maneuvering
   maxSteeringAngle = 4;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 12;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 42;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3000;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1200;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 2100;      // Steering jets (how much you heel over when you turn)
   rollForce = 2;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 200;  // speed in which forward thrust force is no longer applied (meters/second)

   // Turbo Jet
   jetForce = 5000;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 28;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 3.4;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 1.2;

   // Rigid body
   mass = 150;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 14;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 25;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 80;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.06;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23.0;
   collDamageMultiplier   = 0.02;

   //
   minTrailSpeed = 15;      // The speed your contrail shows up at.
   
   //
   max[missileLauncherAmmo] = 1000;

   sensorData = AWACPulseSensor;
   sensorRadius = 800;
   sensorColor = "255 194 9";
   
   numWeapons = 1;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------


datablock ExplosionData(MissileConvoyExplosion) : MissileExplosion
{
   shakeCamera = true;
   camShakeFreq = "4.0 5.0 4.5";
   camShakeAmp = "80.0 80.0 80.0";
   camShakeDuration = 1.6;
   camShakeRadius = 75.0;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock SeekerProjectileData(ShoulderMissileConvoy) : ShoulderMissile
{
   hasDamageRadius     = true;
   indirectDamage      = 1.2;
   damageRadius        = 8.0;
   radiusDamageType    = $DamageType::Missile;
   kickBackStrength    = 2000;

   explosion           = "MissileConvoyExplosion";

   lifetimeMS          = 8500;
   muzzleVelocity      = 5.0;
   maxVelocity         = 1500.0;
   turningSpeed        = 55.0;
   acceleration        = 12.0;

   proximityRadius     = 3;

   terrainAvoidanceSpeed         = 70;
   terrainScanAhead              = 40;
   terrainHeightFail             = 12;
   terrainAvoidanceRadius        = 70;  
   
   flareDistance = 800;
   flareAngle    = 50;

   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(MissileLauncherConvoyAmmo) : MissileLauncherAmmo
{
   computeCRC = false;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(MissileLauncherConvoy) : MissileLauncher
{
   computeCRC = false;
};

datablock ShapeBaseImageData(MissileLauncherConvoyImage) : MissileLauncherImage
{
   item = MissileLauncherConvoy;
   ammo = MissileLauncherConvoyAmmo;

   mountPoint = 10;
   //**original**   offset = ".73 0 0";
   offset = "1.93 -0.52 0.044";

   armThread = lookms;
   emap = true;

   projectile = ShoulderMissileConvoy;
   projectileType = SeekerProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 50;
   fireEnergy = 80;
   fireTimeout = 125;

   isSeeker     = true;
   seekRadius   = 850;
   maxSeekAngle = 24;
   seekTime     = 0.45;
   minSeekHeat  = 0.05;  // the heat that must be present on a target to lock it.

   // only target objects outside this range
   minTargetingDistance             = 30;
   
};


//**************************************************************
// THUNDERSWORD BOMBER
//**************************************************************

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock FlyingVehicleData(BomberFlyerConvoy) : BomberFlyer
{
   shieldDamageScale[$DamageType::Nuke]	= 50.0;
   damageScale[$DamageType::Nuke]	= 4.0;
   shieldDamageScale[$DamageType::Torpedo] = 1.2;
   damageScale[$DamageType::Torpedo] 	 = 0.7;

   computeCRC = false;

   weaponNode = 1;

   drag    = 0.2;
   density = 1.0;

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   cameraMaxDist = 22;
   cameraOffset = 5;
   cameraLag = 1.0;
   explosion = LargeAirVehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   maxDamage = 3.20;     // Total health
   destroyedLevel = 3.20;   // Damage textures show up at this health level

   isShielded = true;
   energyPerDamagePoint = 150;
   maxEnergy = 400;      // Afterburner and any energy weapon pool
   minDrag = 60;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 1800;        // Angular Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.8;

   // Auto stabilize speed
   maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 1500;      // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 300;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't whack out at very slow speeds
   
   // Maneuvering
   maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 5;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 8;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 4700;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1100;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 300;      // Steering jets (how much you heel over when you turn)
   rollForce = 8;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 185;  // speed in which forward thrust force is no longer applied (meters/second)

   // Turbo Jet
   jetForce = 3000;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 40.0;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 3.0;       // Energy use of the afterburners (low number is less drain...can be fractional)
   vertThrustMultiple = 3.0;

   dustEmitter = LargeVehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 2.0;

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 20;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.060;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 25;
   collDamageMultiplier   = 0.020;

};

//**************************************************************
// WEAPONS
//**************************************************************

//-------------------------------------
// BOMBER BOMB PROJECTILE
//-------------------------------------

datablock BombProjectileData(BomberBombConvoy) : BomberBomb
{
   directDamage         = 6.8;
   hasDamageRadius      = true;
   indirectDamage       = 1.8;
   damageRadius         = 40;
   radiusDamageType     = $DamageType::BomberBombs;
   kickBackStrength     = 12500;

   grenadeElasticity    = 0.25;
   grenadeFriction      = 0.4;
   armingDelayMS        = 2000;
   muzzleVelocity       = 0.1;
   drag                 = 0.3;

   minRotSpeed          = "90.0 5.0 0.0";
   maxRotSpeed          = "120.0 45.0 10.0";
};

datablock TurretImageData(BomberBombImageConvoy) : BomberBombImage
{
   projectile                       = BomberBombConvoy;

   fireEnergy                       = 33.0;
   minEnergy                        = 33.0;
};

datablock TurretImageData(BomberBombPairImageConvoy) : BomberBombPairImage
{
   projectile                       = BomberBombConvoy;

   fireEnergy                       = 33.0;
   minEnergy                        = 33.0;
};



//**************************************************************
// HAVOC HEAVY TRANSPORT FLIER
//**************************************************************
//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock FlyingVehicleData(HAPCFlyerConvoy) : HAPCFlyer
{
   shieldDamageScale[$DamageType::Nuke]	= 50.0;
   damageScale[$DamageType::Nuke]	= 3.0;
   shieldDamageScale[$DamageType::Torpedo] = 1.2;
   damageScale[$DamageType::Torpedo] 	 = 0.7;

   computeCRC = false;

   drag = 0.2;
   density = 1.0;

   cameraMaxDist = 17;
   cameraOffset = 2;
   cameraLag = 8.5;
   explosion = LargeAirVehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   maxDamage = 5.50;
   destroyedLevel = 5.50;

   isShielded = true;
   rechargeRate = 0.8;
   energyPerDamagePoint = 120;
   maxEnergy = 550;
   minDrag = 100;                // Linear Drag
   rotationalDrag = 2700;        // Anguler Drag

   // Auto stabilize speed
   maxAutoSpeed = 50;
   autoAngularForce = 3000;      // Angular stabilizer force
   autoLinearForce = 450;        // Linear stabilzer force
   autoInputDamping = 0.95;      // 
                                                        
   // Maneuvering
   maxSteeringAngle = 8;
   horizontalSurfaceForce = 10;  // Horizontal center "wing"
   verticalSurfaceForce = 10;    // Vertical center "wing"
   maneuveringForce = 6000;      // Horizontal jets
   steeringForce = 1000;          // Steering jets
   steeringRollForce = 400;      // Steering jets
   rollForce = 12;               // Auto-roll
   hoverHeight = 8;         // Height off the ground at rest
   createHoverHeight = 6;   // Height off the ground when created
   maxForwardSpeed = 371;  // speed in which forward thrust force is no longer applied (meters/second)

   // Turbo Jet
   jetForce = 10000;
   minJetEnergy = 55;
   jetEnergyDrain = 2.6;
   vertThrustMultiple = 1.3;

   dustEmitter = LargeVehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 2.0;

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 25;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.060;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 28;
   collDamageMultiplier   = 0.020;
};

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

//Convoy Globals
//
//

$Vehiclemax[ScoutVehicleConvoy]     = 6;
$VehicleMax[AssaultVehicleConvoy]   = 4;
$VehicleMax[MobileBaseVehicleConvoy]  = 4;
$VehicleMax[ScoutFlyerConvoy]       = 12;
$VehicleMax[BomberFlyerConvoy]      = 4;
$VehicleMax[HAPCFlyerConvoy]        = 3;

$vehicleReticle[AssaultVehicleConvoy, 1, bitmap] = "gui/hud_ret_tankchaingun";
$vehicleReticle[AssaultVehicleConvoy, 1, frame] = true;
$vehicleReticle[AssaultVehicleConvoy, 2, bitmap] = "gui/hud_ret_tankmortar";
$vehicleReticle[AssaultVehicleConvoy, 2, frame] = true;

$vehicleReticle[BomberFlyerConvoy, 1, bitmap] = "gui/hud_ret_shrike";
$vehicleReticle[BomberFlyerConvoy, 1, frame] = false;
$vehicleReticle[BomberFlyerConvoy, 2, bitmap] = "";
$vehicleReticle[BomberFlyerConvoy, 2, frame] = false;
$vehicleReticle[BomberFlyerConvoy, 3, bitmap] = "gui/hud_ret_targlaser";
$vehicleReticle[BomberFlyerConvoy, 3, frame] = false;


$DeathMessageNukeCount = 18;
$DeathMessageNukeCommonCount = 7;
$DeathMessageNukeUncommonProb = 0.1; //probability that an uncommon DM will be displayed
//rem set prob to ~ .05??
$DeathMessageNuke[0] = '\c0%1 was flattened by the nuclear pulse.';
$DeathMessageNuke[1] = '\c0%1\'s body is now part of the stratosphere.';
$DeathMessageNuke[2] = '\c0%1 helps %3 team by eating the nuke.';
$DeathMessageNuke[3] = '\c0%1 tried to stop the nuke by flailing %3 arms around and yelling \'Mommy\' at the top of %3 lungs.';
$DeathMessageNuke[4] = '\c0%1 decided to head directly into the bright sun-like light. Brilliant!';
$DeathMessageNuke[5] = '\c0%1 found that UV shades don\'t protect all that much against a 12 million degree heatwave.';
$DeathMessageNuke[6] = '\c01 nuclear explosion + %1 = 1 nuclear explosion.';
$DeathMessageNuke[7] = '\c0Pieces of %1 are now being swallowed by a tiny fishie on the other side of the world.';
$DeathMessageNuke[8] = '\c0The Divine Bovine has claimed %1 with a Nuke.';
$DeathMessageNuke[9] = '\c0%1 asks god \'What evil abomination would put nukes in MPB\'s?\'  Alingis smiles back wickedly.';
$DeathMessageNuke[10] = '\c0Nuclear reactor: $4 billion. Missile turret, force shield, and full invo: $2 million. 6 wheels, shoddy suspension, and unlimited mileage: $743.  Watching it all go up in one big mushroom cloud just to take out %1: priceless.';
$DeathMessageNuke[11] = '\c0A frenzy of a fire eats away at %1\'s nuclear corpse.';
$DeathMessageNuke[12] = '\c0%1 found eternal redemption in the form of a nuclear pulse.';
$DeathMessageNuke[13] = '\c0The world is an eerie place. Filled with hope. Filled with fear. Filled with the unknown. But, thanks to a nuke, no longer filled with %1.';
$DeathMessageNuke[14] = '\c0%1 grieves for %3 former life.  Too bad it got banished to nuclear ash.';
$DeathMessageNuke[15] = '\c0%1 suffered a crazy death from a Nuke.';
$DeathMessageNuke[16] = '\c0Love is in the air.  By love, I mean %1.';
$DeathMessageNuke[17] = '\c0Convoy -Nuclear Edition- by Alingis.  Help starving student!  Monetary donations greatly appreciated.  (Pizza is also welcome.)';


$DeathMessageTorpedoCount = 8;
$DeathMessageTorpedoCommonCount = 4;
$DeathMessageTorpedoUncommonProb = 0.3; //probability that an uncommon DM will be displayed
//rem set prob to ~ .05??
$DeathMessageTorpedo[0] = '\c0%1 was obliterated by a torpedo.';
$DeathMessageTorpedo[1] = '\c0%1\'s armor held a living being inside before being crushed by a torpedo.';
$DeathMessageTorpedo[2] = '\c0%1 aids the enemy by eating the torpedo.';
$DeathMessageTorpedo[3] = '\c0%1 tried to stop the Torpedo by flailing %3 arms around and yelling \'I\'m a Gulch!\' at the top of %3 lungs.';
$DeathMessageTorpedo[4] = '\c0%1\'s past life flashes before %3 eyes as he loses this one to a torpedo blast.';
$DeathMessageTorpedo[5] = '\c0In the face of certain death from a torpedo, %1 has nothing but fear to cling to.';
$DeathMessageTorpedo[6] = '\c0%1 looks for hope as the torpedo rushes towards %2, but hope runs away from %2.';
$DeathMessageTorpedo[7] = '\c0The shadow of death looms over %1 in the form of a torpedo.';


///////////////////////////////////////////////////////////////////
//End Convoy Datablocks
///////////////////////////////////////////////////////////////////

//Now the packages!

///////////////////////////////////////////////////////////////////
//Convoy Packages
///////////////////////////////////////////////////////////////////

package ConvoyNEMain {


function SiegeGame::gameOver(%game)
{
	Parent::gameOver(%game);

	deactivatePackage(ConvoyNENuke);
	deactivatePackage(ConvoyNEVehicles);
	deactivatePackage(ConvoyNEDoors);
	deactivatePackage(ConvoyNEMain);
}

function BeginInvincible()
{
        // Makes EquipA invincible (autorepair)
        nameToID(RepA).setRepairRate(5);
        nameToID(RepB).setRepairRate(5);
        nameToID(RepC).setRepairRate(5);
        nameToID(RepD).setRepairRate(5);
        nameToID(RepE).setRepairRate(5);
        nameToID(RepF).setRepairRate(5);
        nameToID(RepG).setRepairRate(5);
        nameToID(RepH).setRepairRate(5);
}


function checkObjectiveReached()
{
	if( game.objectiveReached == 0 )
	{
		checkObjectiveReachedByOne( nameToId("Alpha") );
		checkObjectiveReachedByOne( nameToId("Beta") );
		checkObjectiveReachedByOne( nameToId("Gamma") );
		checkObjectiveReachedByOne( nameToId("Delta") );

		//checks every 5 seconds
		schedule( 5000, 0, checkObjectiveReached );
	}
}



function checkObjectiveReachedByOne(%obj)
{
	%Xpos = getWord(%obj.Position, 0);
	%Ypos = getWord(%obj.Position, 1);
	//%driver = %obj.client;
	if( %Xpos < 4526.92 && %Xpos > 4467.06 && %Ypos < 605.114 && %Ypos > 546.501)
	{
		defenseWins();
		game.objectiveReached = 1;
	}
	else if( %Ypos < -968 || %Ypos > 1560 || %Xpos < -864 || %Xpos > 5153 )
	{
	        	messageAll('MsgMPBOOB', '\c2An MPB has strayed Out-of-bounds and has begun taking damage!');
		%dmg = %obj.getDamageLevel();
		%dmg++;
		if( %dmg > 6 )
		{
			%dmg = 6;
		}
		%obj.setDamageLevel( %dmg );
	}
}

function defenseWins()
{
   game.winByConvoy = 1;
   %defTeam = Game.offenseTeam == 1 ? 2 : 1;
   %offTeam = Game.offenseTeam == 1 ? 1 : 2;

   // Let the observers know:
   messageTeam( 0, 'GotToNeothgard', 'The Convoy reached Neothgard!~wfx/misc/flipflop_taken.wav');
   // Let the teammates know:
   messageTeam( %defTeam, 'GotToNeothgard', 'The Convoy reached Neothgard!~wfx/misc/flipflop_taken.wav');
   // Let the other team know:
   messageTeam( %offTeam, 'GotToNeothgard', 'The Convoy reached Neothgard!~wfx/misc/flipflop_lost.wav');

   Game.allObjectivesCompleted();
}

//overwrites the default siege game allobjectivescompleted function
function SiegeGame::allObjectivesCompleted(%game)
{
   Cancel( %game.timeSync );
   Cancel( %game.timeThread );
   cancelEndCountdown();

    if( game.winByConvoy == 1 )
   {
   	game.winFirstByConvoy = Game.offenseTeam == 1 ? game.winFirstByConvoy : 1;
   	game.winSecondByConvoy = Game.offenseTeam == 1 ? 1 : game.winSecondByConvoy;
   }

   %defenseTeam = %game.offenseTeam == 1 ? 2 : 1;

   //store the elapsed time in the teamScore array...
   if( game.winByConvoy == 1 )
   {
        $teamScore[%defenseTeam] = getSimTime() - %game.startTimeMS;
        messageAll('MsgSiegeArrived', '\c2Team %1 arrived at the base in %2!', $teamName[%defenseTeam], %game.formatTime($teamScore[%defenseTeam], true));

        game.winByConvoy = 0;

      //set the new timelimit
      %game.timeLimitMS = $teamScore[%defenseTeam];
   }
   else
   {
        $teamScore[%game.offenseTeam] = getSimTime() - %game.startTimeMS;
        messageAll('MsgSiegeCaptured', '\c2Team %1 captured the base in %2!', $teamName[%game.offenseTeam], %game.formatTime($teamScore[%game.offenseTeam], true));

      //set the new timelimit
      %game.timeLimitMS = $teamScore[%game.offenseTeam];
   }

echo("defense team: " @ %defenseTeam );
echo("offense team: " @ %game.offenseTeam );
echo("defense team score: " @ $teamScore[%defenseTeam] );
echo("offense team score: " @ $teamScore[%game.offenseTeam] );

   if (%game.firstHalf)
   {
      // it's halftime, let everyone know
      messageAll( 'MsgSiegeHalftime' );
   }
   else
   {
      // game is over
      messageAll('MsgSiegeMisDone', '\c2Mission complete.');
   }
   logEcho("objective completed in "@%game.timeLimitMS);

   //setup the second half...
   // MES -- per MarkF, scheduling for 0 seconds will prevent player deletion-related crashes
   %game.schedule(0, halftime, 'objectives');
}


function SiegeGame::halftime(%game, %reason)
{
   //stop the game and the bots
   $MatchStarted = false;
   AISystemEnabled(false);

   if (%game.firstHalf)
   {
//echo("b4 reset");
      resetStuff();
//echo("after reset");
      //switch the game variables
      %game.firstHalf = false;
      %oldOffenseTeam = %game.offenseTeam;
      if (%game.offenseTeam == 1)
         %game.offenseTeam = 2;
      else
         %game.offenseTeam = 1;

      //send the message
      messageAll('MsgSiegeRolesSwitched', '\c2Team %1 is now on offense.', $teamName[%game.offenseTeam], %game.offenseTeam);

      //reset stations and vehicles that players were using
      %game.resetPlayers();
      // zero out the counts for deployable items (found in defaultGame.cs)
      %game.clearDeployableMaxes();

      // clean up the MissionCleanup group - note, this includes deleting all the player objects
      %clean = nameToID("MissionCleanup");
      %clean.housekeeping();


      // Non static objects placed in original position
      resetNonStaticObjPositions();
      
      // switch the teams for objects belonging to the teams
      %group = nameToID("MissionGroup/Teams");
      %group.swapTeams();
      // search for vehicle pads also
      %mcg = nameToID("MissionCleanup");
      %mcg.swapVehiclePads();

      //restore the objects
      %game.restoreObjects();

      %count = ClientGroup.getCount();
      for(%cl = 0; %cl < %count; %cl++)
      {
         %client = ClientGroup.getObject(%cl);
         if( !%client.isAIControlled() )
         {
            // Put everybody in observer mode:
            %client.camera.getDataBlock().setMode( %client.camera, "observerStaticNoNext" );
            %client.setControlObject( %client.camera );

	// Send the halftime result info:
            	if ( %client.team == %oldOffenseTeam )
            	{
        	       	if ( $teamScore[%oldOffenseTeam] > 0 )
                  	{
			messageClient( %client, 'MsgSiegeResult', "", '%1 captured the %2 base in %3!', %game.capPlayer[%oldOffenseTeam], $teamName[%game.offenseTeam], %game.formatTime( $teamScore[%oldOffenseTeam], true ) );
		}
               		else if ( $teamScore[%offenseTeam] > 0 )
		{
			messageClient( %client, 'MsgSiegeResult', "", '%1 brought their convoy to Neothgard in %2!', $teamName[%game.offenseTeam], %game.formatTime( $teamScore[%offenseTeam], true ) );
		}
		else
                  	{
			messageClient( %client, 'MsgSiegeResult', "", 'Your team failed to capture the %1 base.', $teamName[%game.offenseTeam] );   
            		}
	}
            	else
	{
	 	if ( $teamScore[%oldOffenseTeam] > 0 )
                 		{
			messageClient( %client, 'MsgSiegeResult', "", '%1 captured your base in %2!', %game.capPlayer[%oldOffenseTeam], %game.formatTime( $teamScore[%oldOffenseTeam], true ) );
            		}
		else if ( $teamScore[%offenseTeam] > 0 )
		{
		 	messageClient( %client, 'MsgSiegeResult', "", 'Your team brought the convoy to Neothgard in %1!', %game.formatTime( $teamScore[%oldOffenseTeam], true ) );

		}
		else
               		{
			messageClient( %client, 'MsgSiegeResult', "", 'Your team successfully held off team %1!', $teamName[%oldOffenseTeam] );   
		}            
	}

            // List out the team rosters:
            messageClient( %client, 'MsgSiegeAddLine', "", '<spush><color:00dc00><font:univers condensed:18><clip%%:50>%1</clip><lmargin%%:50><clip%%:50>%2</clip><spop>', $TeamName[1], $TeamName[2] );
            %max = $TeamRank[1, count] > $TeamRank[2, count] ? $TeamRank[1, count] : $TeamRank[2, count];
            for ( %line = 0; %line < %max; %line++ )
            {
               %plyr1 = $TeamRank[1, %line] $= "" ? "" : $TeamRank[1, %line].name;
               %plyr2 = $TeamRank[2, %line] $= "" ? "" : $TeamRank[2, %line].name;
               messageClient( %client, 'MsgSiegeAddLine', "", '<lmargin:0><clip%%:50> %1</clip><lmargin%%:50><clip%%:50> %2</clip>', %plyr1, %plyr2 );
            }

            // Show observers:
            %header = false;
            for ( %i = 0; %i < %count; %i++ )
            {
               %obs = ClientGroup.getObject( %i );
               if ( %obs.team <= 0 )
               {
                  if ( !%header )
                  {
                     messageClient( %client, 'MsgSiegeAddLine', "", '\n<lmargin:0><spush><color:00dc00><font:univers condensed:18>OBSERVERS<spop>' );
                     %header = true;
                  }

                  messageClient( %client, 'MsgSiegeAddLine', "", ' %1', %obs.name );
               }
            }
            
            commandToClient( %client, 'SetHalftimeClock', $Host::Siege::Halftime / 60000 );
            
            // Get the HUDs right:
            commandToClient( %client, 'setHudMode', 'SiegeHalftime' );
            commandToClient( %client, 'ControlObjectReset' );
            
            clientResetTargets(%client, true);
            %client.notReady = true;
         }
      }
      
      %game.schedule( $Host::Siege::Halftime, halftimeOver );
   }
   else
   {
      // let's wrap it all up
      %game.gameOver();
      cycleMissions();
   }
//echo("At end of Halftime report");
//echo("defense team: " @ %oldOffenseTeam );
//echo("offense team: " @ %game.offenseTeam );
//echo("defense team score: " @ $teamScore[%oldOffenseTeam] );
//echo("offense team score: " @ $teamScore[%game.offenseTeam] );

}

function SiegeGame::sendDebriefing( %game, %client )
{
   //if neither team captured
   %winnerName = "";
   if ( $teamScore[1] == 0 && $teamScore[2] == 0 )
      %winner = -1;

   //else see if team1 won
   else if ( $teamScore[1] > 0 && ( $teamScore[2] == 0 || $teamScore[1] < $teamScore[2] ) )
   {
      %winner = 1;
      %winnerName = $teamName[1];
   }

   //else see if team2 won
   else if ($teamScore[2] > 0 && ($teamScore[1] == 0 || $teamScore[2] < $teamScore[1]))
   {
      %winner = 2;
      %winnerName = $teamName[2];
   }

   //else see if it was a tie (right down to the millisecond - doubtful)
   else if ($teamScore[1] == $teamScore[2])
      %winner = 0;

   //send the winner message
   if (%winnerName $= 'Storm')
      messageClient( %client, 'MsgGameOver', "Match has ended.~wvoice/announcer/ann.stowins.wav" );
   else if (%winnerName $= 'Inferno')
      messageClient( %client, 'MsgGameOver', "Match has ended.~wvoice/announcer/ann.infwins.wav" );
   else
      messageClient( %client, 'MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );

   // Mission result:
   if (%winner > 0)
   {
      if (%winner == 1)
      {  
         if ($teamScore[2] == 0)
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 wins!', $TeamName[1]);
         else if( game.winByConvoy == 1 )
         {
            %timeDiffMS = $teamScore[2] - $teamScore[1];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by arriving at Neothgard %2 faster!', $TeamName[1], %game.formatTime(%timeDiffMS, true));
         }
         else
         {
            %timeDiffMS = $teamScore[2] - $teamScore[1];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by capturing the base %2 faster!', $TeamName[1], %game.formatTime(%timeDiffMS, true));
         }
      }
      else
      {
         if ($teamScore[1] == 0)
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 wins!', $TeamName[2]);
         else if( game.winByConvoy == 1 )
         {
            %timeDiffMS = $teamScore[1] - $teamScore[2];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by arriving at Neothgard %2 faster!', $TeamName[2], %game.formatTime(%timeDiffMS, true));
         }
         else
         {
            %timeDiffMS = $teamScore[1] - $teamScore[2];
            messageClient(%client, 'MsgDebriefResult', "", '<just:center>Team %1 won by capturing the base %2 faster!', $TeamName[2], %game.formatTime(%timeDiffMS, true));
         }
      }
   }
   else
      messageClient( %client, 'MsgDebriefResult', "", '<just:center>The mission ended in a tie.' );

   // Game summary:
   messageClient( %client, 'MsgDebriefAddLine', "", '<spush><color:00dc00><font:univers condensed:18>SUMMARY:<spop>' );
   %team1 = %game.offenseTeam == 1 ? 2 : 1;
   %team2 = %game.offenseTeam;
   if ( $teamScore[%team1] > 0 )
   {  
      %timeStr = %game.formatTime($teamScore[%team1], true);
      if( game.winFirstByConvoy == 1 )
	messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>The %1 convoy arrived at Neothgard in %2.<lmargin:0>', $TeamName[%team1], %timeStr);
      else	
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>%1 captured the %2 base for Team %3 in %4.<lmargin:0>', %game.capPlayer[%team1], $TeamName[%team2], $TeamName[%team1], %timeStr);
   }
   else
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>Team %1 failed to capture the base.<lmargin:0>', $TeamName[%team1]);

   if ( $teamScore[%team2] > 0 )
   {  
      %timeStr = %game.formatTime($teamScore[%team2], true);
      if( game.winSecondByConvoy == 1 )
	messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>The %1 convoy arrived at Neothgard in %2.<lmargin:0>', $TeamName[%team2], %timeStr);
      else	
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>%1 captured the %2 base for Team %3 in %4.<lmargin:0>', %game.capPlayer[%team2], $TeamName[%team1], $TeamName[%team2], %timeStr);
   }
   else
      messageClient( %client, 'MsgDebriefAddLine', "", '<bitmap:bullet_2><lmargin:24>Team %1 failed to capture the base.<lmargin:0>', $TeamName[%team2]);

   // List out the team rosters:
   messageClient( %client, 'MsgDebriefAddLine', "", '\n<spush><color:00dc00><font:univers condensed:18><clip%%:50>%1</clip><lmargin%%:50><clip%%:50>%2</clip><spop>', $TeamName[1], $TeamName[2] );
   %max = $TeamRank[1, count] > $TeamRank[2, count] ? $TeamRank[1, count] : $TeamRank[2, count];
   for ( %line = 0; %line < %max; %line++ )
   {
      %plyr1 = $TeamRank[1, %line] $= "" ? "" : $TeamRank[1, %line].name;
      %plyr2 = $TeamRank[2, %line] $= "" ? "" : $TeamRank[2, %line].name;
      messageClient( %client, 'MsgDebriefAddLine', "", '<lmargin:0><clip%%:50> %1</clip><lmargin%%:50><clip%%:50> %2</clip>', %plyr1, %plyr2 );
   }

   // Show observers:
   %count = ClientGroup.getCount();
   %header = false;
   for ( %i = 0; %i < %count; %i++ )
   {
      %cl = ClientGroup.getObject( %i );
      if ( %cl.team <= 0 )
      {
         if ( !%header )
         {
            messageClient( %client, 'MsgDebriefAddLine', "", '\n<lmargin:0><spush><color:00dc00><font:univers condensed:18>OBSERVERS<spop>' );
            %header = true;
         }

         messageClient( %client, 'MsgDebriefAddLine', "", ' %1', %cl.name );
      }
   }
}




function SiegeGame::updateScoreHud(%game, %client, %tag)
{
   %timeElapsedMS = getSimTime() - %game.startTimeMS;
   %curTimeLeftMS = %game.timeLimitMS - %timeElapsedMS;
   %game.defenseTeam = %game.offenseTeam == 1 ? 2 : 1;

   if (!$MatchStarted)
      %curTimeLeftStr = %game.formatTime(%game.timelimitMS, false);
   else
      %curTimeLeftStr = %game.formatTime(%curTimeLeftMS, false);

   // Send header:
   if (%game.firstHalf)
      messageClient( %client, 'SetScoreHudHeader', "", '<just:center>Team %1 has %2 to capture the base.', 
            $teamName[%game.offenseTeam], %curTimeLeftStr ); 
   else
     if( game.winByConvoy == 1 )
        messageClient( %client, 'SetScoreHudHeader', "", '<just:center>Team %1 must reach Neothgard within %2 to win.', 
            $teamName[%game.defenseTeam], %curTimeLeftStr );
     else 
        messageClient( %client, 'SetScoreHudHeader', "", '<just:center>Team %1 must capture the base within %2 to win.', 
            $teamName[%game.offenseTeam], %curTimeLeftStr );

   // Send subheader:
   messageClient( %client, 'SetScoreHudSubheader', "", '<tab:15,315>\t%1 (%2)\t%3 (%4)',
         $TeamName[1], $TeamRank[1, count], $TeamName[2], $TeamRank[2, count] );

   %index = 0;
   while (true)
   {
      if (%index >= $TeamRank[1, count] && %index >= $TeamRank[2, count])
         break;

      //get the team1 client info
      %team1Client = "";
      %team1ClientScore = "";
      %col1Style = "";
      if (%index < $TeamRank[1, count])
      {
         %team1Client = $TeamRank[1, %index];
         %team1ClientScore = %team1Client.score $= "" ? 0 : %team1Client.score;
         if ( %team1Client == %client )
            %col1Style = "<color:dcdcdc>";
      }

      //get the team2 client info
      %team2Client = "";
      %team2ClientScore = "";
      %col2Style = "";
      if (%index < $TeamRank[2, count])
      {
         %team2Client = $TeamRank[2, %index];
         %team2ClientScore = %team2Client.score $= "" ? 0 : %team2Client.score;
         if ( %team2Client == %client )
            %col2Style = "<color:dcdcdc>";
      }


      //if the client is not an observer, send the message
      if (%client.team != 0)
      {
         messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20,320>\t<spush>%3<clip:200>%1</clip><spop>\t%4<clip:200>%2</clip>', 
               %team1Client.name, %team2Client.name, %col1Style, %col2Style );
      }
      //else for observers, create an anchor around the player name so they can be observed
      else
      {
         messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20,320>\t<spush>%3<clip:200><a:gamelink\t%5>%1</a></clip><spop>\t%4<clip:200><a:gamelink\t%6>%2</a></clip>', 
               %team1Client.name, %team2Client.name, %col1Style, %col2Style, %team1Client, %team2Client );
      }

      %index++;
   }

   // Tack on the list of observers:
   %observerCount = 0;
   for (%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl = ClientGroup.getObject(%i);
      if (%cl.team == 0)
         %observerCount++;
   }

   if (%observerCount > 0)
   {
	   messageClient( %client, 'SetLineHud', "", %tag, %index, "");
      %index++;
		messageClient(%client, 'SetLineHud', "", %tag, %index, '<tab:10, 310><spush><font:Univers Condensed:22>\tOBSERVERS (%1)<rmargin:260><just:right>TIME<spop>', %observerCount);
      %index++;
      for (%i = 0; %i < ClientGroup.getCount(); %i++)
      {
         %cl = ClientGroup.getObject(%i);
         //if this is an observer
         if (%cl.team == 0)
         {
            %obsTime = getSimTime() - %cl.observerStartTime;
            %obsTimeStr = %game.formatTime(%obsTime, false);
		      messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20, 310>\t<clip:150>%1</clip><rmargin:260><just:right>%2',
		                     %cl.name, %obsTimeStr );
            %index++;
         }
      }
   }

   //clear the rest of Hud so we don't get old lines hanging around...
   messageClient( %client, 'ClearHud', "", %tag, %index );
}



//checks if all gens are dead, if so, special fx on switch
function AnotherDead()
{
	//echo("in anotherDead");
	game.gensDead = game.gensDead + 1;
	if( game.gensDead == 4 ) 
	{
		%fX = "372";
		%fY = "585";
		%fZ = "138";
		schedule(5000, 0, "randomDet", %fX, %fY, %fZ );
	}
}

function randomDet(%posX,%posY,%posZ)
{
	//echo("in randomDet");
	%newpos = %posX SPC %posY SPC %posZ;

	%thrownItem = new Item()
	{
         dataBlock = genGrenLong;
    	};
	MissionCleanup.add(%thrownItem);

	%thrownItem.setTransform(%newpos);
	schedule(2000, %thrownItem, "detonateGrenade", %thrownItem);

	%thrownItem = new Item()
	{
         dataBlock = genGrenMed;
    	};
	MissionCleanup.add(%thrownItem);

	%thrownItem.setTransform(%newpos);
	schedule(2000, %thrownItem, "detonateGrenade", %thrownItem);

	%thrownItem = new Item()
	{
         dataBlock = genGrenSlow;
    	};
	MissionCleanup.add(%thrownItem);

	%thrownItem.setTransform(%newpos);
	schedule(2000, %thrownItem, "detonateGrenade", %thrownItem);

	%thrownItem = new Item()
	{
         dataBlock = genGrenRealSlow;
    	};
	MissionCleanup.add(%thrownItem);

	%thrownItem.setTransform(%newpos);
	schedule(2000, %thrownItem, "detonateGrenade", %thrownItem);

	%thrownItem = new Item()
	{
         dataBlock = genGrenRealFast;
    	};
	MissionCleanup.add(%thrownItem);

	%thrownItem.setTransform(%newpos);
	schedule(2000, %thrownItem, "detonateGrenade", %thrownItem);

	%thrownItem = new Item()
	{
         dataBlock = nukeBasic;
    	};
	MissionCleanup.add(%thrownItem);

	%thrownItem.setTransform(%newpos);
	schedule(2500, %thrownItem, "detonateGrenade", %thrownItem);

}

//kills gens on mpb destruction
function VehicleData::onDestroyed(%data, %obj, %prevState)
{
	//echo("in onDestroyed");
	Parent::onDestroyed(%data,%obj,%prevState);

	if(%obj == nameToId("Alpha") )
	{
	  	MessageAll('MsgAlphaDown', "\c2Alpha Generator Destroyed!");

		OpenDoor(NameToID("TowerA"), 5000, 0, 0, 0, -30 );
		game.adown = 1;

		%fX = getWord(%obj.Position, 0);
		%fY = getWord(%obj.Position, 1);
		%fZ = getWord(%obj.Position, 2);
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower1Gen").setDamageLevel(2.5);
		AnotherDead();
	}
	else if(%obj == nameToId("Beta") )
	{
	  	MessageAll('MsgBetaDown', "\c2Beta Generator Destroyed!");

		OpenDoor(NameToID("TowerB"), 5000, 0, 0, 0, -30 );
		game.bdown = 1;

		%fX = getWord(%obj.Position, 0);
		%fY = getWord(%obj.Position, 1);
		%fZ = getWord(%obj.Position, 2);
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower2Gen").setDamageLevel(2.5);

		AnotherDead();
	}
	else if(%obj == nameToId("Gamma") )
	{
	  	MessageAll('MsgGammaDown', "\c2Gamma Generator Destroyed!");

		OpenDoor(NameToID("TowerC"), 5000, 0, 0, 0, -30 );
		game.cdown = 1;

		%fX = getWord(%obj.Position, 0);
		%fY = getWord(%obj.Position, 1);
		%fZ = getWord(%obj.Position, 2);
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower3Gen").setDamageLevel(2.5);

		AnotherDead();
	}
	else if(%obj == nameToId("Delta") )
	{
	  	MessageAll('MsgDeltaDown', "\c2Delta Generator Destroyed!");

		OpenDoor(NameToID("TowerD"), 5000, 0, 0, 0, -30 );
		game.ddown = 1;

		%fX = getWord(%obj.Position, 0);
		%fY = getWord(%obj.Position, 1);
		%fZ = getWord(%obj.Position, 2);
		randomDet( %fX, %fY, %fZ );
		nameToId("Tower4Gen").setDamageLevel(2.5);

		AnotherDead();
	}
}



//reset at the half
function resetStuff()
{
	if( game.adown == 1 )
		OpenDoor(NameToID("TowerA"), 500, 0, 0, 0, 30 );
	if( game.bdown == 1 )
		OpenDoor(NameToID("TowerB"), 500, 0, 0, 0, 30 );
	if( game.cdown == 1 )
		OpenDoor(NameToID("TowerC"), 500, 0, 0, 0, 30 );
	if( game.ddown == 1 )
		OpenDoor(NameToID("TowerD"), 500, 0, 0, 0, 30 );
}

function SiegeGame::halftimeOver( %game )
{
//	Parent::halfTimeOver(%game);
	//echo("in halftimeover");
	game.gensDown = 0;

	//delete all starting vehivles
	nameToId("Tower1Gen").setDamageLevel(0.0);
	nameToId("Tower2Gen").setDamageLevel(0.0);
	nameToId("Tower3Gen").setDamageLevel(0.0);
	nameToId("Tower4Gen").setDamageLevel(0.0);


	//reset all start vehicles
	Convoy::resetVehicles(%game);

	game.objectiveReached = 0;
	game.gensDead = 0;
	//check for a defensive win begginning at 1min in
	schedule( 60000, 0, checkObjectiveReached );
	BeginInvincible();

	Parent::halfTimeOver(%game);
}

function Convoy::resetVehicles(%game)
{
	%dTeam = %game.offenseTeam == 1 ? 2 : 1;

				%temp = new WheeledVehicle(Alpha) {
					position = "453 555.505 131.206";
					rotation = "0.00962178 -0.00249749 0.999951 29.0949";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicleConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = %dTeam;
						mountable = "1";
						Target = "46";
						respawn = "0";
      					   teamBought = %dTeam;
					         resetPos = "";
					         respawnTime = "";
					         marker = "";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
				%temp = new WheeledVehicle(Beta) {
					position = "448 522.111 131.21";
					rotation = "0.00974623 -0.00262915 0.999949 33.8035";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicleConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = %dTeam;
						mountable = "1";
						Target = "47";
						respawn = "0";
      					   teamBought = %dTeam;
					         resetPos = "";
					         respawnTime = "";
					         marker = "";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
				%temp = new WheeledVehicle(Gamma) {
					position = "420 529.295 131.228";
					rotation = "0.00651722 -0.0099132 0.99993 37.0242";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicleConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = %dTeam;
						mountable = "1";
						Target = "48";
						respawn = "0";
      					   teamBought = %dTeam;
					         resetPos = "";
					         respawnTime = "";
					         marker = "";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
				%temp = new WheeledVehicle(Delta) {
					position = "398 506.06 131.206";
					rotation = "0.00925353 -0.00250766 0.999954 30.3183";
					scale = "1 1 1";
					dataBlock = "mobileBaseVehicleConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = %dTeam;
						mountable = "1";
						Target = "49";
						respawn = "0";
      					   teamBought = %dTeam;
					         resetPos = "";
					         respawnTime = "";
					         marker = "";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
				%temp = new FlyingVehicle(Extra1) {
					position = "353 495.892 133.937";
					rotation = "0 0 1 48.1282";
					scale = "1 1 1";
					dataBlock = "ScoutFlyerConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
					selfPower = "1";
						locked = "true";
						Target = "55";
						nextWeaponFire = "2";
						mountable = "1";
						team = %dTeam;
						respawn = "0";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
				%temp = new FlyingVehicle() {
					position = "363 464.036 133.937";
					rotation = "0 0 1 45.2636";
					scale = "1 1 1";
					dataBlock = "ScoutFlyerConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = %dTeam;
						mountable = "1";
						nextWeaponFire = "2";
						Target = "56";
						respawn = "0";
      					   teamBought = %dTeam;
					         resetPos = "";
					         respawnTime = "";
					         marker = "";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
				%temp = new HoverVehicle() {
					position = "457 573.453 131.031";
					rotation = "0 0 1 60.7331";
					scale = "1 1 1";
					dataBlock = "AssaultVehicleConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = %dTeam;
						mountable = "1";
						turretObject = "3372";
						Target = "51";
						respawn = "0";
      					   teamBought = %dTeam;
					         resetPos = "";
					         respawnTime = "";
					         marker = "";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
				%temp = new HoverVehicle() {
					position = "377 493.875 131.031";
					rotation = "0 0 1 30.9397";
					scale = "1 1 1";
					dataBlock = "AssaultVehicleConvoy";
					lockCount = "0";
					homingCount = "0";
					disableMove = "0";
						selfPower = "1";
						locked = "true";
						team = %dTeam;
						mountable = "1";
						turretObject = "3374";
						Target = "53";
						respawn = "0";
      					   teamBought = %dTeam;
					         resetPos = "";
					         respawnTime = "";
					         marker = "";
				};
      setTargetSensorGroup(%temp.target, %temp.team);
      MissionCleanup.add(%temp);
}

function SiegeGame::MissionLoadDone(%game)
{
	Parent::MissionLoadDone(%game);


	// start the convoy stuff
	BeginInvincible();

	// do the Convoy Shuffle
	//reset all start vehicles
	Convoy::resetVehicles(%game);

	//check for a defensive win begginning at 1min in
	schedule( 60000, 0, checkObjectiveReached );

	game.gensDead = 0;
	game.winByConvoy = 0;
	game.winFirstByConvoy = 0;
	game.winSecondByConvoy = 0;
	game.objectiveReached = 0;
	game.startDmg = 0;

	game.adown = 0;
	game.bdown = 0;
	game.cdown = 0;
	game.ddown = 0;
}


}; //end of package ConvoyNEMain

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

package ConvoyNEVehicles {

function clearVehicleCount(%team)
{
   $VehicleTotalCount[%team, ScoutVehicleConvoy]      = 0;
   $VehicleTotalCount[%team, AssaultVehicleConvoy]    = 0;
   $VehicleTotalCount[%team, MobileBaseVehicleConvoy] = 0;
   $VehicleTotalCount[%team, ScoutFlyerConvoy]        = 0;
   $VehicleTotalCount[%team, BomberFlyerConvoy]       = 0;
   $VehicleTotalCount[%team, HAPCFlyerConvoy]         = 0;
   $VehicleTotalCount[%team, ScoutVehicle]      = 0;
   $VehicleTotalCount[%team, AssaultVehicle]    = 0;
   $VehicleTotalCount[%team, MobileBaseVehicle] = 0;
   $VehicleTotalCount[%team, ScoutFlyer]        = 0;
   $VehicleTotalCount[%team, BomberFlyer]       = 0;
   $VehicleTotalCount[%team, HAPCFlyer]         = 0;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

////////////////////
//updateHud overwrite uses default vehicles for the hud, but provides the values
//  for Convoy vehicle max and remaining 
//- implements the "classic" mod fix for updateHud
////////////////////
function VehicleHud::updateHud( %obj, %client, %tag )
{
   %station = %client.player.station;
   %team = %client.getSensorGroup();
   %count = 0;
   %none = "-";

   %vehmsg = %station.vehicle[ScoutVehicle] ? "( 1 )   GRAV CYCLE                        " : %none;
   %numleft = %station.vehicle[ScoutVehicle] ? ($VehicleMax[ScoutVehicleConvoy] - $VehicleTotalCount[%team, ScoutVehicleConvoy]) : 0;
   messageClient( %client, 'SetLineHud', "", %tag, %count, %vehmsg, "", ScoutVehicle, %numleft );
   %count++;

   %vehmsg = %station.vehicle[AssaultVehicle] ? "( 2 )   ASSAULT TANK                    " : %none;
   %numleft = %station.vehicle[AssaultVehicle] ? ($VehicleMax[AssaultVehicleConvoy] - $VehicleTotalCount[%team, AssaultVehicleConvoy]) : 0;   
   messageClient( %client, 'SetLineHud', "", %tag, %count, %vehmsg, "", AssaultVehicle, %numleft );
   %count++;

   %vehmsg = %station.vehicle[mobileBaseVehicle] ? "( 3 )   MOBILE POINT BASE               " : %none;
   %numleft = %station.vehicle[MobileBaseVehicle] ? ($VehicleMax[MobileBaseVehicleConvoy] - $VehicleTotalCount[%team, MobileBaseVehicleConvoy]) : 0;      
   messageClient( %client, 'SetLineHud', "", %tag, %count, %vehmsg, "", MobileBaseVehicle, %numleft );
   %count++;

   %vehmsg = %station.vehicle[scoutFlyer] ? "( 4 )   SCOUT FLIER                       " : %none;
   %numleft = %station.vehicle[ScoutFlyer] ? ($VehicleMax[ScoutFlyerConvoy] - $VehicleTotalCount[%team, ScoutFlyerConvoy]) : 0;         
   messageClient( %client, 'SetLineHud', "", %tag, %count, %vehmsg, "", ScoutFlyer, %numleft );
   %count++;

   %vehmsg = %station.vehicle[bomberFlyer] ? "( 5 )   BOMBER                             " : %none;
   %numleft = %station.vehicle[BomberFlyer] ? ($VehicleMax[BomberFlyerConvoy] - $VehicleTotalCount[%team, BomberFlyerConvoy]) : 0;
   messageClient( %client, 'SetLineHud', "", %tag, %count, %vehmsg, "", BomberFlyer, %numleft );
   %count++;

   %vehmsg = %station.vehicle[hapcFlyer] ? "( 6 )   TRANSPORT                        " : %none;
   %numleft = %station.vehicle[HAPCFlyer] ? ($VehicleMax[HAPCFlyerConvoy] - $VehicleTotalCount[%team, HAPCFlyerConvoy]) : 0;   
   messageClient( %client, 'SetLineHud', "", %tag, %count, %vehmsg, "", HAPCFlyer, %numleft ); 
}


function serverCmdBuyVehicle(%client, %blockName)
{
		// echo("In serverCmdBuyVehicle: %blockName = " @ %blockName );
//////////////////////////////////////////
//Convoy vehicles end in "Convoy"
	%blocknameOld = %blockname;
	%blockname = %blocknameOld @ "Convoy";
//////////////////////////////////////////
		//echo("--- %blockName = " @ %blockName );

   %team = %client.getSensorGroup();
   if(vehicleCheck(%blockname, %team))        
   {
		//echo("--- passed vehicleCheck");
      %station = %client.player.station.pad;
      if( (%station.ready) && (%station.station.vehicle[%blocknameOld]) )
      {
         %trans = %station.getTransform();
         %pos = getWords(%trans, 0, 2);
         %matrix = VectorOrthoBasis(getWords(%trans, 3, 6));
         %yrot = getWords(%matrix, 3, 5);
         %p = vectorAdd(%pos,vectorScale(%yrot, -3));
         %p =  getWords(%p,0, 1) @ " " @ getWord(%p,2) + 4;

//         error(%blockName);
//         error(%blockName.spawnOffset);

         %p = vectorAdd(%p, %blockName.spawnOffset);
         %rot = getWords(%trans, 3, 5);
         %angle = getWord(%trans, 6) + 3.14;
         %mask = $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | 
                 $TypeMasks::StationObjectType | $TypeMasks::TurretObjectType;
	      InitContainerRadiusSearch(%p, %blockName.checkRadius, %mask);
   
	      %clear = 1;
         for (%x = 0; (%obj = containerSearchNext()) != 0; %x++) 
         {
            if((%obj.getType() & $TypeMasks::VehicleObjectType) && (%obj.getDataBlock().checkIfPlayersMounted(%obj)))
            {
               %clear = 0;
               break;
            }
            else
               %removeObjects[%x] = %obj;
         }
         if(%clear)
         {
            %fadeTime = 0;
            for(%i = 0; %i < %x; %i++)
            {
               if(%removeObjects[%i].getType() & $TypeMasks::PlayerObjectType)
               {
                  %pData = %removeObjects[%i].getDataBlock();
                  %pData.damageObject(%removeObjects[%i], 0, "0 0 0", 1000, $DamageType::VehicleSpawn);
               }
               else
               {
                  %removeObjects[%i].mountable = 0;
                  %removeObjects[%i].startFade( 1000, 0, true );
                  %removeObjects[%i].schedule(1001, "delete");
                  %fadeTime = 1500;
               }
            }
            schedule(%fadeTime, 0, "createVehicle", %client, %station, %blockName, %team , %p, %rot, %angle);
         }
         else
            MessageClient(%client, "", 'Can\'t create vehicle. A player is on the creation pad.'); 
      }
   }
}

////////////////////////////////////////////////////////////////////////

function AssaultVehicleConvoy::onDamage(%this, %obj)
{
	AssaultVehicle::onDamage(%this, %obj);
}

function BomberFlyerConvoy::onDamage(%this, %obj)
{
	BomberFlyer::onDamage(%this, %obj);
}

function MobileBaseVehicleConvoy::onDamage(%this, %obj)
{
	MobileBaseVehicle::onDamage(%this, %obj);
}

//----------------------------
// SHRIKE SCOUT FLIER
//----------------------------

function ScoutFlyerConvoy::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(MissileLauncherConvoyImage, 0);
//   %obj.mountImage(MissileLauncherConvoyImage, 2);
//   %obj.mountImage(MissileLauncherConvoyImage, 3);
   %obj.nextWeaponFire = 2;
   %obj.schedule(5500, "playThread", $ActivateThread, "activate");
}

//----------------------------
// WILDCAT GRAV CYCLE
//----------------------------

function ScoutVehicleConvoy::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(TorpedoImage, 0);
   %obj.mountImage(TorpedoImage, 2);
   %obj.mountImage(TorpedoImage, 3);
   %obj.nextWeaponFire = 2;
   %obj.schedule(5500, "playThread", $ActivateThread, "activate");
}


//----------------------------
// THUNDERSWORD BOMBER
//----------------------------

function BomberFlyerConvoy::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
  
   %turret = TurretData::create(BomberTurret);
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.selectedWeapon = 1;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(BomberTurretBarrel,2);
   %turret.mountImage(BomberTurretBarrelPair,3);
   %turret.mountImage(BomberBombImageConvoy, 4);
   %turret.mountImage(BomberBombPairImageConvoy, 5);
   %turret.mountImage(BomberTargetingImage, 6);
   %obj.turretObject = %turret;
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %turret.vehicleMounted = %obj;
   
   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);

   //for this particular weapon - a non-firing datablock used only so the AI can aim the turret
   //Also needed so we can set the turret parameters..
   %turret.mountImage(AIAimingTurretBarrel, 0);

   // setup the turret's target info
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
}

//----------------------------
// HAVOC TRANSPORT FLIER
//----------------------------

function HAPCFlyerConvoy::onAdd(%this, %obj)
{
	HAPCFlyer::onAdd(%this, %obj);
}

//----------------------------
// BEOWULF ASSAULT VEHICLE
//----------------------------

function AssaultVehicleConvoy::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   
   %turret = TurretData::create(AssaultPlasmaTurret);
   %turret.selectedWeapon = 1;
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(AssaultPlasmaTurretBarrel, 2);
   %turret.mountImage(AssaultMortarConvoyTurretBarrel, 4);
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %obj.turretObject = %turret;
   
   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);
   
   //Needed so we can set the turret parameters..
   %turret.mountImage(AssaultTurretParam, 0);
   %obj.schedule(6000, "playThread", $ActivateThread, "activate");

   // set the turret's target info
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
}

//----------------------------
// JERICHO FORWARD BASE (Mobile Point Base)
//----------------------------

function MobileBaseVehicleConvoy::onAdd(%this, %obj)
{
	MobileBaseVehicle::onAdd(%this, %obj);
}

//**************************************************************
//* MULTI-CREW VEHICLE DELETION
//**************************************************************

//----------------------------
//BEOWULF ASSAULT VEHICLE
//----------------------------

function AssaultVehicleConvoy::deleteAllMounted(%data, %obj)
{
	AssaultVehicle::deleteAllMounted(%data, %obj);
}

//----------------------------
// THUNDERSWORD BOMBER
//----------------------------

function BomberFlyerConvoy::deleteAllMounted(%data, %obj)
{
	BomberFlyer::deleteAllMounted(%data, %obj);
}

//----------------------------
// JERICHO FORWARD BASE
//----------------------------

function MobileBaseVehicleConvoy::deleteAllMounted(%data, %obj)
{
	MobileBaseVehicle::deleteAllMounted(%data, %obj);
}

//**************************************************************
//* WEAPON MOUNTING ON VEHICLES
//**************************************************************

//----------------------------
// WILDCAT GRAV CYCLE
//----------------------------

function ScoutVehicleConvoy::playerMounted(%data, %obj, %player, %node)
{
   // scout vehicle == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

//----------------------------
// SHRIKE SCOUT FLIER
//----------------------------

function ScoutFlyerConvoy::playerMounted(%data, %obj, %player, %node)
{
	ScoutFlyer::playerMounted(%data, %obj, %player, %node);
}

//----------------------------
// THUNDERSWORD BOMBER
//----------------------------

function BomberFlyerConvoy::playerMounted(%data, %obj, %player, %node)
{
	BomberFlyer::playerMounted(%data, %obj, %player, %node);
}

//----------------------------
// HAVOC TRANSPORT FLIER
//----------------------------

function HAPCFlyerConvoy::playerMounted(%data, %obj, %player, %node)
{
	HAPCFlyer::playerMounted(%data, %obj, %player, %node);
}

//----------------------------
// BEOWULF ASSAULT VEHICLE
//----------------------------

function AssaultVehicleConvoy::playerMounted(%data, %obj, %player, %node)
{
	AssaultVehicle::playerMounted(%data, %obj, %player, %node);
}

//----------------------------
// JERICHO FORWARD BASE
//----------------------------

function MobileBaseVehicleConvoy::playerMounted(%data, %obj, %player, %node)
{
	MobileBaseVehicle::playerMounted(%data, %obj, %player, %node);
}

function MobileBaseVehicleConvoy::playerDismounted(%data, %obj, %player)
{
	MobileBaseVehicle::playerDismounted(%data, %obj, %player);
}

//**************************************************************
//* JERICHO DEPLOYMENT and UNDEPLOYMENT
//**************************************************************

function MobileBaseVehicleConvoy::vehicleDeploy(%data, %obj, %player, %force)
{ 
   if(VectorLen(%obj.getVelocity()) <= 0.1 || %force)
   {
      %deployMessage = "";
      if( (%deployMessage = %data.checkTurretDistance(%obj)) $= "" || %force)
      {
         if(%obj.station $= "")
         {
            if( (%deployMessage = %data.checkDeploy(%obj)) $= "" || %force)
            {
               %obj.station = new StaticShape() {
                  scale = "1 1 1";
                  dataBlock = "MobileInvStation";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
                  vehicle = %obj;
               };                
               %obj.station.startFade(0,0,true);
               %obj.mountObject(%obj.station, 2);
               %obj.station.getDataBlock().createTrigger(%obj.station);
               %obj.station.setSelfPowered();
               %obj.station.playThread($PowerThread,"Power");
               %obj.station.playAudio($HumSound,StationHumSound);
               %obj.station.vehicle = %obj;
               %obj.turret = new turret() {
                  scale = "1 1 1";
                  dataBlock = "MobileTurretBaseConvoy";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
               };                
               %obj.turret.setDamageLevel(%obj.getDamageLevel());
               %obj.mountObject(%obj.turret, 1);
               %obj.turret.setSelfPowered();
               %obj.turret.playThread($PowerThread,"Power");
               %obj.turret.mountImage(MissileBarrelLarge, 0 ,false);

               %obj.beacon = new BeaconObject() {
                  dataBlock = "DeployedBeacon";
                  position = %obj.position;
                  rotation = %obj.rotation;
                  team = %obj.team;
               };
               %obj.beacon.setBeaconType(friend);
               %obj.beacon.setTarget(%obj.team);
               
               checkSpawnPos(%obj, 20);
            }
         }
         else
         {
            %obj.station.setSelfPowered();
            %obj.station.playThread($PowerThread,"Power");
            %obj.turret.setSelfPowered();
            %obj.turret.playThread($PowerThread,"Power");
         }
         if(%deployMessage $= "" || %force)
         {
            if(%obj.turret.getTarget() == -1)
            {   
               %obj.turret.setTarget(%obj.turret.target);
            }   
            %obj.turret.setThreadDir($DeployThread, true);
            %obj.turret.playThread($DeployThread,"deploy");
            %obj.turret.playAudio($DeploySound, MobileBaseTurretDeploySound);
         
            %obj.station.notDeployed = 1;
            %obj.setThreadDir($DeployThread, true);
            %obj.playThread($DeployThread,"deploy");  
            %obj.playAudio($DeploySound, MobileBaseDeploySound);
            %obj.deployed = 1;
            %obj.deploySchedule = "";
            %obj.disableMove = true;
            %obj.setFrozenState(true);
            if(isObject(%obj.shield))
               %obj.shield.delete();

            %obj.shield = new forceFieldBare()
            {
               scale = "1.22 1.8 1.1";
               dataBlock = "defaultTeamSlowFieldBare";
               team = %obj.team;
            };
            %obj.shield.open();
            setTargetSensorData(%obj.getTarget(), MPBDeployedSensor);
         }
      }
      if(%deployMessage !$= "")
         messageClient(%player.client, '', %deployMessage); 

      return true;
   }
   else
   {
      return false;
   }
}
function MobileBaseVehicleConvoy::onEndSequence(%data, %obj, %thread)
{
	MobileBaseVehicle::onEndSequence(%data, %obj, %thread);
}

function MobileBaseVehicleConvoy::checkDeploy(%data, %obj)
{
	MobileBaseVehicle::checkDeploy(%data, %obj);   
}
function MobileBaseVehicleConvoy::checkTurretDistance(%data, %obj)
{
	MobileBaseVehicle::checkTurretDistance(%data, %obj);
}

function findAIEmptySeat(%vehicle, %player)
{
   %dataBlock = %vehicle.getDataBlock();
	if (%dataBlock.getName() $= "BomberFlyerConvoy")
		%num = 2;
	else
		%num = 1;
	%node = -1;
	for(%i = %num; %i < %dataBlock.numMountPoints; %i++)
	{
	   if (!%vehicle.getMountNodeObject(%i))
	   {
	      //cheap hack - for now, AI's will mount the next available node regardless of where they collided
	      %node = %i;
	      break;
	   }
	}

	//return the empty seat
	return %node;
}

function MissileLauncherConvoyImage::onFire(%data,%obj,%slot)
{
   %p = Parent::onFire(%data, %obj, %slot);
   MissileSet.add(%p);
   
   %target = %obj.getLockedTarget();
   if(%target)
      %p.setObjectTarget(%target);
   else if(%obj.isLocked())
      %p.setPositionTarget(%obj.getLockedPosition());
   else
      %p.setNoTarget();
}

function MissileLauncherConvoyImage::onWetFire(%data, %obj, %slot)
{
   %p = Parent::onFire(%data, %obj, %slot);
   MissileSet.add(%p);
   
   %p.setObjectTarget(0);
}

};
//end of package ConvoyNEVehicles

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////



package ConvoyNEDoors {

function OpenDoor(%Door, %Time, %Frames, %MoveX, %MoveY, %MoveZ)
{
   //Takes an object and moves it over the time specified in ms, using a specified number of frames
   //
   //Proper usage: 
   //
   // OpenDoor(<ObjectToBeMoved>, <TimeInMS>, <#OfFramesToUse>, <XOffset>, <YOffset>, <ZOffset> );   
   //
   // So:
   // OpenDoor(NameToID("TheDoor"), 3000, 100, 10, 0, 0 );
   //                Moves "TheDoor" 10m in the x direction over 3 seconds and uses 100 frames
   //
   // Note: best used with small objects, if frames is <= 0, it will be set to 30 fps
   //
   // Note that frames should be large enough to look smooth, and small enough not to eat up to much proccessing time:  
   //  100 is a generally good setting, but play with it as desired
   //
   // Thanx to Dev for the Waterlevel script, this is based off that :)

  if(!isObject(%Door)) //If it isnt an object, error
  {
    echo("Unable to set movement on non-object classes, First parameter invalid");
    return;
  }
    //echo("Moving Object...");

   if(%Frames <= 0)
   {
     %Frames = 30 * %Time / 1000;
   }


   // Loop through and schedule the moving of the door now.   
   %i = 1;
   %deltaX = %MoveX / %Frames;
   %deltaY = %MoveY / %Frames;
   %deltaZ = %MoveZ / %Frames;

   while (%i <= %Frames)
   {
      Schedule(%i  / %Frames * %Time, 0, MoveDoor, %Door, %deltaX, %deltaY, %deltaZ);
   
      %i++;   
   }
    //echo("after scheduling, i: " @ %i );
}

//actually does the move

function MoveDoor(%Door, %ChangeX, %ChangeY, %ChangeZ)
{
   %MoveX = getWord(%Door.Position, 0) + %ChangeX;
   %MoveY = getWord(%Door.Position, 1) + %ChangeY;
   %MoveZ = getWord(%Door.Position, 2) + %ChangeZ;

   %Door.Position = %MoveX @ " " @ %MoveY @ " " @ %MoveZ;
   //echo("Door position: " @ %Door.position );
   // Just needed to cause a refresh
   %rot = rotFromTransform(%Door.getTransform());

   %Door.setTransForm(%Door.Position SPC %rot);

}

};//end package ConvoyNEDoors


/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

package ConvoyNENuke {

// death messages override for "nuke" death messages
function DefaultGame::displayDeathMessages(%game, %clVictim, %clKiller, %damageType, %implement)
{
	//echo("in display death msg");
   // ----------------------------------------------------------------------------------
   // z0dd - ZOD, 6/18/02. From Panama Jack, send the damageTypeText as the last varible
   // in each death message so client knows what weapon it was that killed them.

   %victimGender = (%clVictim.sex $= "Male" ? 'him' : 'her');
   %victimPoss = (%clVictim.sex $= "Male" ? 'his' : 'her');
   %killerGender = (%clKiller.sex $= "Male" ? 'him' : 'her');
   %killerPoss = (%clKiller.sex $= "Male" ? 'his' : 'her');
   %victimName = %clVictim.name;
   %killerName = %clKiller.name;
   //echo( $DamageType::Nuke @ " DamageType = " @ %damageType @ ", implement = " @ %implement @ ", implement class = " @ %implement.getClassName() @ ", is controlled = " @ %implement.getControllingClient());
   
   if(%damageType == $DamageType::Explosion)
   {      
      messageAll('msgExplosionKill', $DeathMessageExplosion[mFloor(getRandom() * $DeathMessageExplosionCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by a nearby explosion.");
   }
   else if(%damageType == $DamageType::Nuke)
   {      
	//echo("displaying nuked death msg");
	%ranRes = mFloor(getRandom() * $DeathMessageNukeCommonCount);
	if( getRandom() < $DeathMessageNukeUncommonProb )
		%ranRes = mFloor(getRandom() * $DeathMessageNukeCount);
      messageAll('msgNukeKill', $DeathMessageNuke[%ranRes], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by a nuke.");
   }
   else if(%damageType == $DamageType::Torpedo)
   {      
	//echo("displaying nuked death msg");
	%ranRes = mFloor(getRandom() * $DeathMessageTorpedoCommonCount);
	if( getRandom() < $DeathMessageTorpedoUncommonProb )
		%ranRes = mFloor(getRandom() * $DeathMessageTorpedoCount);
      messageAll('msgTorpedoKill', $DeathMessageTorpedo[%ranRes], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by a torpedo.");
   }
   else if(%damageType == $DamageType::Suicide)  //player presses cntrl-k
   {
      messageAll('msgSuicide', $DeathMessageSuicide[mFloor(getRandom() * $DeathMessageSuicideCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") committed suicide (CTRL-K)");
   }
	else if(%damageType == $DamageType::VehicleSpawn)
	{
      messageAll('msgVehicleSpawnKill', $DeathMessageVehPad[mFloor(getRandom() * $DeathMessageVehPadCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by vehicle spawn");
	}
	else if(%damageType == $DamageType::ForceFieldPowerup)
	{
      messageAll('msgVehicleSpawnKill', $DeathMessageFFPowerup[mFloor(getRandom() * $DeathMessageFFPowerupCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by Force Field Powerup");
	}
	else if(%damageType == $DamageType::Crash)
	{
      messageAll('msgVehicleCrash', $DeathMessageVehicleCrash[%damageType, mFloor(getRandom() * $DeathMessageVehicleCrashCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") crashes a vehicle.");
	}
	else if(%damageType == $DamageType::Impact) // run down by vehicle
	{
		if( ( %controller = %implement.getControllingClient() ) > 0)
		{
	      %killerGender = (%controller.sex $= "Male" ? 'him' : 'her');
	      %killerPoss = (%controller.sex $= "Male" ? 'his' : 'her');           
	      %killerName = %controller.name;
			messageAll('msgVehicleKill', $DeathMessageVehicle[mFloor(getRandom() * $DeathMessageVehicleCount)], %victimName, %victimGender, %victimPoss, %killerName ,%killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
	      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by a vehicle controlled by "@%controller);
		}
		else
		{
			messageAll('msgVehicleKill', $DeathMessageVehicleUnmanned[mFloor(getRandom() * $DeathMessageVehicleUnmannedCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
	      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by a vehicle (unmanned)");
		}
	}
   else if (isObject(%implement) && (%implement.getClassName() $= "Turret" || %implement.getClassName() $= "VehicleTurret" || %implement.getClassName() $= "FlyingVehicle" ))   //player killed by a turret
   {
      if (%implement.getControllingClient() != 0)  //is turret being controlled?
      {
         %controller = %implement.getControllingClient();
         %killerGender = (%controller.sex $= "Male" ? 'him' : 'her');
         %killerPoss = (%controller.sex $= "Male" ? 'his' : 'her');           
         %killerName = %controller.name;

         if (%controller == %clVictim)
            messageAll('msgTurretSelfKill', $DeathMessageTurretSelfKill[mFloor(getRandom() * $DeathMessageTurretSelfKillCount)],%victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
         else if (%controller.team == %clVictim.team) //controller TK'd a friendly     
            messageAll('msgCTurretKill', $DeathMessageCTurretTeamKill[%damageType, mFloor(getRandom() * $DeathMessageCTurretTeamKillCount)],%victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
         else //controller killed an enemy
            messageAll('msgCTurretKill', $DeathMessageCTurretKill[%damageType, mFloor(getRandom() * $DeathMessageCTurretKillCount)],%victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
         logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by a turret controlled by "@%controller);
      }
      // use the handle associated with the deployed object to verify valid owner
      else if (isObject(%implement.owner))
      {        
         %owner = %implement.owner;
         //error("Owner is " @ %owner @ "   Handle is " @ %implement.ownerHandle);
         //error("Turret is still owned");
         //turret is uncontrolled, but is owned - treat the same as controlled.
         %killerGender = (%owner.sex $= "Male" ? 'him' : 'her');
         %killerPoss = (%owner.sex $= "Male" ? 'his' : 'her');          
         %killerName = %owner.name;

         if (%owner.team == %clVictim.team)  //player got in the way of a teammates deployed but uncontrolled turret.
            messageAll('msgCTurretKill', $DeathMessageCTurretAccdtlKill[%damageType,mFloor(getRandom() * $DeathMessageCTurretAccdtlKillCount)],%victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
         else  //deployed, uncontrolled turret killed an enemy
            messageAll('msgCTurretKill', $DeathMessageCTurretKill[%damageType,mFloor(getRandom() * $DeathMessageCTurretKillCount)],%victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
         logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") was killed by turret (automated)");
      }
      else  //turret is not a placed (owned) turret (or owner is no longer on it's team), and is not being controlled
      {
         messageAll('msgTurretKill', $DeathMessageTurretKill[%damageType,mFloor(getRandom() * $DeathMessageTurretKillCount)],%victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
         logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by turret");
      }
   }
   else if((%clKiller == %clVictim) || (%damageType == $DamageType::Ground)) //player killed himself or fell to death
   {
      messageAll('msgSelfKill', $DeathMessageSelfKill[%damageType,mFloor(getRandom() * $DeathMessageSelfKillCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed self ("@getTaggedString($DamageTypeText[%damageType])@")");
   }
   
   else if (%damageType == $DamageType::OutOfBounds) //killer died due to Out-of-Bounds damage
   {
      messageAll('msgOOBKill', $DeathMessageOOB[mFloor(getRandom() * $DeathMessageOOBCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by out-of-bounds damage");
   }

   else if (%damageType == $DamageType::NexusCamping) //Victim died from camping near the nexus...
   {
      messageAll('msgCampKill', $DeathMessageCamping[mFloor(getRandom() * $DeathMessageCampingCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed for nexus camping");
   }

   else if(%clKiller.team == %clVictim.team) //was a TK
   {
      messageAll('msgTeamKill', $DeathMessageTeamKill[%damageType, mFloor(getRandom() * $DeathMessageTeamKillCount)],  %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") teamkilled by "@%clKiller.nameBase@" (pl "@%clKiller.player@"/cl "@%clKiller@")");
   }
   
   else if (%damageType == $DamageType::Lava)   //player died by falling in lava
   {
      messageAll('msgLavaKill',  $DeathMessageLava[mFloor(getRandom() * $DeathMessageLavaCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by lava");
   }
   else if ( %damageType == $DamageType::Lightning )  // player was struck by lightning
   {
      messageAll('msgLightningKill',  $DeathMessageLightning[mFloor(getRandom() * $DeathMessageLightningCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by lightning");
   }
   else if ( %damageType == $DamageType::Mine && !isObject(%clKiller) )
   {
         error("Mine kill w/o source");
         messageAll('MsgRogueMineKill', $DeathMessageRogueMine[%damageType, mFloor(getRandom() * $DeathMessageRogueMineCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
   }
   else  //was a legitimate enemy kill
   {  
      if(%damageType == 6 && (%clVictim.headShot))
      {	          
         // laser headshot just occurred         
         messageAll('MsgHeadshotKill', $DeathMessageHeadshot[%damageType, mFloor(getRandom() * $DeathMessageHeadshotCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
            
      }
      else   
         messageAll('MsgLegitKill', $DeathMessage[%damageType, mFloor(getRandom() * $DeathMessageCount)], %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType, $DamageTypeText[%damageType]);
      logEcho(%clVictim.nameBase@" (pl "@%clVictim.player@"/cl "@%clVictim@") killed by "@%clKiller.nameBase@" (pl "@%clKiller.player@"/cl "@%clKiller@") using "@getTaggedString($DamageTypeText[%damageType]));
   }
}

};// end of package ConvoyNENuke


///////////////////////////////////////////////////////////////////
//End Convoy Packages
///////////////////////////////////////////////////////////////////
